// -*- mode: c++ -*-
// 
// File MDF.C generated by TMultiDimFit::MakeRealCode
// on Mon Dec 11 23:16:34 2006
// ROOT version 5.13/07
//
// This file contains the function 
//
//    double  MDF(double *x); 
//
// For evaluating the parameterization obtained
// from TMultiDimFit and the point x
// 
// See TMultiDimFit class documentation for more information 
// 
//
// Static data variables
//
static int    gNVariables    = 4;
static int    gNCoefficients = 21;
static double gDMean         = 48.0217;
// Assignment to mean vector.
static double gXMean[] = {
  0.00728665, 0.033764, -0.020799, -0.000315398 };

// Assignment to minimum vector.
static double gXMin[] = {
  0.00240535, 0.00381892, 0.00760952, 0.00836567 };

// Assignment to maximum vector.
static double gXMax[] = {
  9.99454, 9.99284, 9.94596, 9.99761 };

// Assignment to coefficients vector.
static double gCoefficient[] = {
  -4.70776,
  43.3519,
  13.5699,
  13.3169,
  13.5708,
  13.5311,
  13.6633,
  13.2718,
  -4.21843,
  4.65398,
  4.5217,
  -4.01994,
  4.57828,
  -4.11152,
  3.68617,
  -4.37356,
  4.62783,
  4.26708,
  -3.98121,
  -3.52323,
  4.55097
 };

// Assignment to error coefficients vector.
static double gCoefficientRMS[] = {
  0.0984437,
  0.170247,
  0.0819164,
  0.0797336,
  0.0778529,
  0.138821,
  0.139623,
  0.135253,
  0.140165,
  0.151168,
  0.157515,
  0.14579,
  0.155207,
  0.137935,
  0.250589,
  0.255915,
  0.255668,
  0.2641,
  0.247128,
  0.236459,
  0.267068
 };

// Assignment to powers vector.
// The powers are stored row-wise, that is
//  p_ij = gPower[i * NVariables + j];
static int    gPower[] = {
  1,  1,  1,  1,
  2,  1,  1,  1,
  1,  1,  1,  2,
  1,  1,  2,  1,
  1,  2,  1,  1,
  2,  2,  1,  1,
  2,  1,  1,  2,
  2,  1,  2,  1,
  1,  2,  1,  2,
  1,  1,  3,  1,
  1,  1,  1,  3,
  1,  1,  2,  2,
  1,  3,  1,  1,
  1,  2,  2,  1,
  1,  2,  2,  2,
  2,  2,  1,  2,
  2,  1,  3,  1,
  2,  1,  1,  3,
  2,  1,  2,  2,
  2,  2,  2,  1,
  2,  3,  1,  1
};

// 
// The function   double MDF(double *x)
// 
double MDF(double *x) {
  double returnValue = gDMean;
  int    i = 0, j = 0, k = 0;
  for (i = 0; i < gNCoefficients ; i++) {
    // Evaluate the ith term in the expansion
    double term = gCoefficient[i];
    for (j = 0; j < gNVariables; j++) {
      // Evaluate the polynomial in the jth variable.
      int power = gPower[gNVariables * i + j]; 
      double p1 = 1, p2 = 0, p3 = 0, r = 0;
      double v =  1 + 2. / (gXMax[j] - gXMin[j]) * (x[j] - gXMax[j]);
      // what is the power to use!
      switch(power) {
      case 1: r = 1; break; 
      case 2: r = v; break; 
      default: 
        p2 = v; 
        for (k = 3; k <= power; k++) { 
          p3 = p2 * v;
          p1 = p2; p2 = p3; 
        }
        r = p3;
      }
      // multiply this term by the poly in the jth var
      term *= r; 
    }
    // Add this term to the final result
    returnValue += term;
  }
  return returnValue;
}

// EOF for MDF.C
